package compositeidentifiers;

import org.hibernate.*;
import org.hibernate.cfg.*;
import java.util.*;

public class Main {

    public static void main(String[] args) {
        Session session1 = null;
        Session session2 = null;
        Ulica u = new Ulica();
        u.setNazwa("Szewska");
        u.setMiasto("Wrocław");
        u.setZabytkowa(true);

        SessionFactory sessionFactory = null;

        try {
            sessionFactory = new Configuration().configure().buildSessionFactory();
            session1 = sessionFactory.openSession();
            Transaction tx1 = session1.beginTransaction();
            session1.saveOrUpdate(u);
            tx1.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session1.flush();
            session1.close();
        }

        try {
            session2 = sessionFactory.openSession();
            Transaction tx2 = session2.beginTransaction();
            System.out.println("--------- Pierwszy sposób ---------");
            String SQL_QUERY = "from Ulica as u order by u.Nazwa asc";
            Query query = session2.createQuery(SQL_QUERY);
            System.out.println(String.format("Znaleziono: %d", query.list().size()));
            for (Object o : query.list()) {
                Ulica ux = (Ulica) o;
                System.out.println(String.format(
                        "Nazwa: %s \t Miasto: %s \t Czy zabytkowa: %s",
                        ux.getNazwa(), ux.getMiasto(), ux.isZabytkowa() ? "tak" : "nie"));
            }
            System.out.println("--------- Drugi sposób ---------");
            //UlicaId uid = new UlicaId("Szewska", "Wrocław");
            Ulica u2 = new Ulica();
            u2.setNazwa("Szewska");
            u2.setMiasto("Wrocław");
            u2 = (Ulica) session2.get(Ulica.class, u2);
            System.out.println(String.format(
                    "Nazwa: %s \t Miasto: %s \t Czy zabytkowa: %s",
                    u2.getNazwa(), u2.getMiasto(), u2.isZabytkowa() ? "tak" : "nie"));

            tx2.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session2.flush();
            session2.close();
        }
    }
}
