package compositeidentifiers2;

import org.hibernate.*;
import org.hibernate.cfg.*;
import java.util.*;

public class Main {

    public static void main(String[] args) {
        Session session1 = null;
        Session session2 = null;
        Ulica u = new Ulica();
        u.setId(new UlicaId("Szewska", "Wrocław"));
        u.setZabytkowa(true);

        SessionFactory sessionFactory = null;

        try {
            sessionFactory = new Configuration().configure().buildSessionFactory();
            session1 = sessionFactory.openSession();
            Transaction tx1 = session1.beginTransaction();
            session1.saveOrUpdate(u);
            tx1.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session1.flush();
            session1.close();
        }

        try {
            session2 = sessionFactory.openSession();
            Transaction tx2 = session2.beginTransaction();
            UlicaId uid = new UlicaId("Szewska", "Wrocław");
            Ulica u2 = (Ulica) session2.load(Ulica.class, uid);
            System.out.println(String.format(
                    "Nazwa: %s \t Miasto: %s \t Czy zabytkowa: %s",
                    u2.getId().getNazwa(), u2.getId().getMiasto(), u2.isZabytkowa() ? "tak" : "nie"));
            tx2.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session2.flush();
            session2.close();
        }
    }
}
