/*
 * 
 * Przygotowanie bazy danych
 * 
 * CREATE TABLE MESSAGES(MESSAGE_ID INT NOT NULL PRIMARY KEY, TEXT VARCHAR2(255), NEXT_MESSAGE_ID INT)
 * 
 */
package helloworld;

import org.hibernate.*;
import org.hibernate.cfg.*;
import java.util.*;

public class HelloWorld {

    public static void main(String[] args) {
        Message message1 = new Message("Witaj świecie 001");
        Message message2 = new Message("Witaj świecie 002");

        Session session1 = null;
        Session session2 = null;
        Session session3 = null;

        SessionFactory sessionFactory = null;

        try {
            sessionFactory = new Configuration().configure().buildSessionFactory();
            session1 = sessionFactory.openSession();
            Transaction tx1 = session1.beginTransaction();
            session1.saveOrUpdate(message1);
            tx1.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session1.flush();
            session1.close();
        }

        try {
            session2 = sessionFactory.openSession();
            Transaction tx2 = session2.beginTransaction();
            Message m = (Message) session2.get(Message.class, new Long(1));
            m.setNextMessage(message2);
            session2.saveOrUpdate(m);
            tx2.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session2.flush();
            session2.close();
        }

        try {
            session3 = sessionFactory.openSession();
            Transaction tx3 = session3.beginTransaction();
            String SQL_QUERY = "from Message as m order by m.text asc";
            Query query = session3.createQuery(SQL_QUERY);
            System.out.println(String.format("Znaleziono: %d", query.list().size()));
            for (Object o : query.list()) {
                Message m = (Message) o;
                System.out.println(String.format("ID: %d \t Text: %s", m.getId(), m.getText()));
            }
//            Iterator<Message> iterator = query.iterate();
//            while (iterator.hasNext()) {
//                Message m = iterator.next();
//                System.out.println(String.format("ID: %d \t Text: %s", m.getId(), m.getText()));
//            }
            tx3.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session3.flush();
            session3.close();
        }
    }
}
