/* Przygotowanie bazy danych

select * from koszyk
select * from produkt
select * from atrybuty

begin
execute immediate 'drop table produkt';
execute immediate 'drop table atrybuty';
execute immediate 'drop table koszyk';
end;

begin
execute immediate 'create table koszyk ( id int primary key, klient varchar2(50) )';
execute immediate 'create table produkt ( id int primary key, nazwa varchar2(50), cena float, koszyk_id int )';
execute immediate 'create table atrybuty ( koszyk_id int, atrybut varchar2(255) )';
end;

*/
package persistencebyreachability2;

import java.util.*;
import org.hibernate.*;
import org.hibernate.cfg.*;

public class Main {

    public static void main(String[] args) {
        Produkt p1 = new Produkt();
        p1.setNazwa("Banany");
        p1.setCena(3.0);

        Produkt p2 = new Produkt();
        p2.setNazwa("Czekolada");
        p2.setCena(4.0);

        Koszyk k = new Koszyk();
        k.setKlient("Jan Kowalski");

        k.getProdukty().add(p1);
        k.getProdukty().add(p2);

        k.getAtrybuty().add("data powstania");
        k.getAtrybuty().add("data realizacji");

        // W pliku mapującym upewniamy się, że w obu miejscach jest save-update
        Session session1;
        SessionFactory sessionFactory = new Configuration().configure().buildSessionFactory();
        session1 = sessionFactory.openSession();
        Transaction tx1 = session1.beginTransaction();
        session1.save(k);
        tx1.commit();

        // Poniższe wykonujemy dwa razy: raz bez zmian, za drugim razem dodajemy delete-orphan
        Transaction tx2 = session1.beginTransaction();
        Produkt p = (Produkt) k.getProdukty().iterator().next();
        String s = (String) k.getAtrybuty().iterator().next();
        k.getProdukty().remove(p);
        k.getAtrybuty().remove(s);
        //session1.delete(p); // nie chcemy musieć to wywoływać
        tx2.commit();

        session1.close();
    }
}
