package usingcomponents;

import org.hibernate.*;
import org.hibernate.cfg.*;
import java.util.*;

public class Main {

    public static void main(String[] args) {
        Session session1 = null;
        Session session2 = null;
        Adres domowyAdres = new Adres();
        domowyAdres.setUlica("Grabiszyńska");
        domowyAdres.setMiasto("Wrocław");
        Adres sluzbowyAdres = new Adres();
        sluzbowyAdres.setUlica("Szczytnicka");
        sluzbowyAdres.setMiasto("Wrocław");
        Uzytkownik user = new Uzytkownik();
        user.setImie("Jan");
        user.setNazwisko("Kowalski");
        user.setDomowyAdres(domowyAdres);
        user.setSluzbowyAdres(sluzbowyAdres);
        
        SessionFactory sessionFactory = null;

        try {
            sessionFactory = new Configuration().configure().buildSessionFactory();
            session1 = sessionFactory.openSession();
            Transaction tx1 = session1.beginTransaction();
            session1.saveOrUpdate(user);
            tx1.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session1.flush();
            session1.close();
        }

        try {
            session2 = sessionFactory.openSession();
            Transaction tx2 = session2.beginTransaction();
            String SQL_QUERY = "from Uzytkownik as u order by u.Nazwisko asc";
            Query query = session2.createQuery(SQL_QUERY);
            System.out.println(String.format("Znaleziono: %d", query.list().size()));
            for (Object obj : query.list()) {
                Uzytkownik u = (Uzytkownik) obj;
                System.out.println(String.format(
                        "ID: %d \t Imie: %s \t Nazwisko: %s \t Ulica (dom): %s \t Ulica (praca): %s",
                        u.getId(), u.getImie(), u.getNazwisko(), u.getDomowyAdres().getUlica(), u.getSluzbowyAdres().getUlica()));
            }
            tx2.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session2.flush();
            session2.close();
        }
    }

}
