package usingobjects;

import org.hibernate.*;
import org.hibernate.cfg.*;

public class Main {

    public static void main(String[] args) {

        // Utrwalenie obiektu
        SessionFactory sf = null;
        Session session = null;
        User user = new User();
        user.setFirstName("John");
        user.setLastName("Doe");
        User user2 = new User();
        user2.setFirstName("Ewa");
        user2.setLastName("Malinowski");
        try {
            sf = new Configuration().configure().buildSessionFactory();
            session = sf.openSession();
            Transaction tx = session.beginTransaction();
            session.save(user);
            session.save(user2);
            tx.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session.close();
        }

        // Aktualizacja stanu trwałego obiektu odłączonego
        Session session2 = null;
        try {
            user.setPassword("Tajne");
            session2 = sf.openSession();
            Transaction tx = session2.beginTransaction();
            session2.update(user);
            user.setFirstName("Jan");
            tx.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session2.close();
        }
        
        //Pobranie obiektu trwałego
        Session session3 = null;
        try {
            session3 = sf.openSession();
            //Transaction tx = session3.beginTransaction();
            int userId = 1;
            User u = (User) session3.get(User.class, userId);
            System.out.println(String.format("%d : %s : %s : %s", u.getId(), u.getFirstName(), u.getLastName(), u.getPassword()));
            //tx.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session3.close();
        }

        // Aktualizacja obiektu trwałego
        Session session4 = null;
        try {
            session4 = sf.openSession();
            Transaction tx = session4.beginTransaction();
            int userId = 1;
            User u = (User) session4.get(User.class, userId);
            u.setFirstName("John");
            tx.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session4.close();
        }
        
        // Zmiana obiektu trwałego na ulotny
        Session session5 = null;
        try {
            session5 = sf.openSession();
            Transaction tx = session5.beginTransaction();
            int userId = 1;
            User u = (User) session5.get(User.class, userId);
            session5.delete(u);
            tx.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session5.close();
        }

        // Zmiana obiektu odłączonego na ulotny
        Session session6 = null;
        try {
            session6 = sf.openSession();
            Transaction tx = session6.beginTransaction();
            session6.delete(user2);
            tx.commit();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            session6.close();
        }
    }
}
